Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nintendo.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nintendo.pm	(revision 34921)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nintendo.pm	(revision 34921)
@@ -0,0 +1,128 @@
+#------------------------------------------------------------------------------
+# File:         Nintendo.pm
+#
+# Description:  Nintendo EXIF maker notes tags
+#
+# Revisions:    2014/03/25 - P. Harvey Created
+#
+# References:   1) http://3dbrew.org/wiki/MPO
+#------------------------------------------------------------------------------
+
+package Image::ExifTool::Nintendo;
+
+use strict;
+use vars qw($VERSION);
+use Image::ExifTool::Exif;
+
+$VERSION = '1.00';
+
+%Image::ExifTool::Nintendo::Main = (
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    WRITE_PROC => \&Image::ExifTool::Exif::WriteExif,
+    CHECK_PROC => \&Image::ExifTool::Exif::CheckExif,
+    WRITABLE => 1,
+    # 0x1000 - undef[28]
+    # 0x1001 - undef[8]
+    # 0x1100 - undef[80] (found in MPO files)
+    0x1101 => {
+        Name => 'CameraInfo',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Nintendo::CameraInfo',
+            ByteOrder => 'Little-endian',
+        },
+    },
+);
+
+# Nintendo MPO info (ref 1)
+%Image::ExifTool::Nintendo::CameraInfo = (
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    WRITABLE => 1,
+    PRIORITY => 0,
+    FORMAT => 'int8u',
+    FIRST_ENTRY => 0,
+    0x00 => { # "3DS1"
+        Name => 'ModelID',
+        Format => 'undef[4]',
+    },
+    # 0x04 - int32u: 1,2,4,5
+    0x08 => {
+        Name => 'TimeStamp',
+        Format => 'int32u',
+        Groups => { 2 => 'Time' },
+        Shift => 'Time',
+        # zero time is 2000/01/01 (10957 days after Unix time zero)
+        ValueConv => 'ConvertUnixTime($val + 10957 * 24 * 3600)',
+        ValueConvInv => 'GetUnixTime($val) - 10957 * 24 * 3600',
+        PrintConv => '$self->ConvertDateTime($val)',
+        PrintConvInv => '$self->InverseDateTime($val)',
+    },
+    # 0x10 - int32u: title ID low
+    # 0x14 - int32u: flags
+    0x18 => {
+        Name => 'InternalSerialNumber',
+        Groups => { 2 => 'Camera' },
+        Format => 'undef[4]',
+        ValueConv => '"0x" . unpack("H*",$val)',
+        ValueConvInv => '$val=~s/^0x//; pack("H*",$val)',
+    },
+    0x28 => {
+        Name => 'Parallax',
+        Format => 'float',
+        PrintConv => 'sprintf("%.2f", $val)',
+        PrintConvInv => '$val',
+    },
+    0x30 => {
+        Name => 'Category',
+        Format => 'int16u',
+        PrintHex => 1,
+        PrintConv => {
+            0x0000 => '(none)',
+            0x1000 => 'Mii',
+            0x2000 => 'Man',
+            0x4000 => 'Woman',
+        },
+    },
+    # 0x32 - int16u: filter
+);
+
+1;  # end
+
+__END__
+
+=head1 NAME
+
+Image::ExifTool::Nintendo - Nintendo EXIF maker notes tags
+
+=head1 SYNOPSIS
+
+This module is loaded automatically by Image::ExifTool when required.
+
+=head1 DESCRIPTION
+
+This module contains definitions required by Image::ExifTool to
+interpret Nintendo maker notes EXIF meta information.
+
+=head1 AUTHOR
+
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
+
+This library is free software; you can redistribute it and/or modify it
+under the same terms as Perl itself.
+
+=head1 REFERENCES
+
+=over 4
+
+=item L<http://3dbrew.org/wiki/MPO>
+
+=back
+
+=head1 SEE ALSO
+
+L<Image::ExifTool::TagNames/Nintendo Tags>,
+L<Image::ExifTool(3pm)|Image::ExifTool>
+
+=cut
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/OOXML.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/OOXML.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/OOXML.pm	(revision 34921)
@@ -15,5 +15,5 @@
 use Image::ExifTool::ZIP;
 
-$VERSION = '1.05';
+$VERSION = '1.08';
 
 # test for recognized OOXML document extensions
@@ -22,4 +22,5 @@
     DOTX => 1,  DOTM => 1,
     POTX => 1,  POTM => 1,
+    PPAX => 1,  PPAM => 1,
     PPSX => 1,  PPSM => 1,
     PPTX => 1,  PPTM => 1,  THMX => 1,
@@ -64,8 +65,8 @@
 
         B<Tips:>
-        
+
         1) Structural ZIP tags may be ignored (if desired) with C<--ZIP:all> on the
         command line.
-        
+
         2) Tags may be grouped by their document number in the ZIP archive with the
         C<-g3> or C<-G3> option.
@@ -135,5 +136,5 @@
     MMClips     => { },
     modified    => {
-        Name => 'ModifyDate', 
+        Name => 'ModifyDate',
         Groups => { 2 => 'Time' },
         Format => 'date',
@@ -209,17 +210,17 @@
 sub FoundTag($$$$;$)
 {
-    my ($exifTool, $tagTablePtr, $props, $val, $attrs) = @_;
+    my ($et, $tagTablePtr, $props, $val, $attrs) = @_;
     return 0 unless @$props;
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
 
     my $tag = $$props[-1];
-    $exifTool->VPrint(0, "  | - Tag '", join('/',@$props), "'\n") if $verbose > 1;
+    $et->VPrint(0, "  | - Tag '", join('/',@$props), "'\n") if $verbose > 1;
 
     # un-escape XML character entities
     $val = Image::ExifTool::XMP::UnescapeXML($val);
-    # convert OOXML-escaped characters (ie. "_x0000d_" is a newline)
+    # convert OOXML-escaped characters (eg. "_x0000d_" is a newline)
     $val =~ s/_x([0-9a-f]{4})_/Image::ExifTool::PackUTF8(hex($1))/gie;
     # convert from UTF8 to ExifTool Charset
-    $val = $exifTool->Decode($val, 'UTF8');
+    $val = $et->Decode($val, 'UTF8');
     # queue this attribute for later if necessary
     if ($queueAttrs{$tag}) {
@@ -247,6 +248,6 @@
                 $tagInfo{PrintConv} = '$self->ConvertDateTime($val)';
             }
-            $exifTool->VPrint(0, "  | [adding $tag]\n") if $verbose;
-            Image::ExifTool::AddTagToTable($tagTablePtr, $tag, \%tagInfo);
+            $et->VPrint(0, "  | [adding $tag]\n") if $verbose;
+            AddTagToTable($tagTablePtr, $tag, \%tagInfo);
         }
     } elsif ($tag eq 'xmlns') {
@@ -289,9 +290,9 @@
         }
     } else {
-        $exifTool->VPrint(0, "  [adding $tag]\n") if $verbose;
-        Image::ExifTool::AddTagToTable($tagTablePtr, $tag, { Name => ucfirst $tag });
+        $et->VPrint(0, "  [adding $tag]\n") if $verbose;
+        AddTagToTable($tagTablePtr, $tag, { Name => ucfirst $tag });
     }
     # save the tag
-    $exifTool->HandleTag($tagTablePtr, $tag, $val);
+    $et->HandleTag($tagTablePtr, $tag, $val);
 
     # start fresh for next tag
@@ -312,5 +313,5 @@
 sub ProcessDOCX($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $zip = $$dirInfo{ZIP};
     my $tagTablePtr = GetTagTable('Image::ExifTool::OOXML::Main');
@@ -321,15 +322,15 @@
     if ($fileType) {
         # THMX is a special case because its contents.main MIME types is PPTX
-        if ($fileType eq 'PPTX' and $$exifTool{FILE_EXT} and $$exifTool{FILE_EXT} eq 'THMX') {
+        if ($fileType eq 'PPTX' and $$et{FILE_EXT} and $$et{FILE_EXT} eq 'THMX') {
             $fileType = 'THMX';
         }
     } else {
-        $exifTool->VPrint(0, "Unrecognized MIME type: $mime\n");
+        $et->VPrint(0, "Unrecognized MIME type: $mime\n");
         # get MIME type according to file extension
-        $fileType = $$exifTool{FILE_EXT};
+        $fileType = $$et{FILE_EXT};
         # default to 'DOCX' if this isn't a known OOXML extension
         $fileType = 'DOCX' unless $fileType and $isOOXML{$fileType};
     }
-    $exifTool->SetFileType($fileType);
+    $et->SetFileType($fileType);
 
     # must catch all Archive::Zip warnings
@@ -343,16 +344,17 @@
         my $file = $member->fileName();
         next unless defined $file;
-        $exifTool->VPrint(0, "File: $file\n");
+        $et->VPrint(0, "File: $file\n");
         # set the document number and extract ZIP tags
-        $$exifTool{DOC_NUM} = ++$docNum;
-        Image::ExifTool::ZIP::HandleMember($exifTool, $member);
-        # process only XML and JPEG files in "docProps" directory
-        next unless $file =~ m{^docProps/.*\.(xml|jpe?g)$}i;
+        $$et{DOC_NUM} = ++$docNum;
+        Image::ExifTool::ZIP::HandleMember($et, $member);
+        # process only XML and JPEG/WMF thumbnail images in "docProps" directory
+        next unless $file =~ m{^docProps/(.*\.xml|(thumbnail\.(jpe?g|wmf)))$}i;
         # get the file contents (CAREFUL! $buff MUST be local since we hand off a value ref)
         my ($buff, $status) = $zip->contents($member);
-        $status and $exifTool->Warn("Error extracting $file"), next;
-        # extract JPEG as PreviewImage (should only be docProps/thumbnail.jpeg)
-        if ($file =~ /\.jpe?g/i) {
-            $exifTool->FoundTag('PreviewImage', \$buff);
+        $status and $et->Warn("Error extracting $file"), next;
+        # extract docProps/thumbnail.(jpg|mwf) as PreviewImage|PreviewMWF
+        if ($file =~ /\.(jpe?g|wmf)$/i) {
+            my $tag = $file =~ /\.wmf$/i ? 'PreviewWMF' : 'PreviewImage';
+            $et->FoundTag($tag, \$buff);
             next;
         }
@@ -366,8 +368,8 @@
             },
         );
-        $exifTool->ProcessDirectory(\%dirInfo, $tagTablePtr);
+        $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
         undef $buff;    # (free memory now)
     }
-    delete $$exifTool{DOC_NUM};
+    delete $$et{DOC_NUM};
     return 1;
 }
@@ -394,5 +396,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Ogg.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Ogg.pm	(revision 34921)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Ogg.pm	(revision 34921)
@@ -0,0 +1,240 @@
+#------------------------------------------------------------------------------
+# File:         Ogg.pm
+#
+# Description:  Read Ogg meta information
+#
+# Revisions:    2011/07/13 - P. Harvey Created (split from Vorbis.pm)
+#               2016/07/14 - PH Added Ogg Opus support
+#
+# References:   1) http://www.xiph.org/vorbis/doc/
+#               2) http://flac.sourceforge.net/ogg_mapping.html
+#               3) http://www.theora.org/doc/Theora.pdf
+#------------------------------------------------------------------------------
+
+package Image::ExifTool::Ogg;
+
+use strict;
+use vars qw($VERSION);
+use Image::ExifTool qw(:DataAccess :Utils);
+
+$VERSION = '1.02';
+
+my $MAX_PACKETS = 2;    # maximum packets to scan from each stream at start of file
+
+# Information types recognizedi in Ogg files
+%Image::ExifTool::Ogg::Main = (
+    NOTES => q{
+        ExifTool extracts the following types of information from Ogg files.  See
+        L<http://www.xiph.org/vorbis/doc/> for the Ogg specification.
+    },
+    # (these are for documentation purposes only, and aren't used by the code below)
+    vorbis => { SubDirectory => { TagTable => 'Image::ExifTool::Vorbis::Main' } },
+    theora => { SubDirectory => { TagTable => 'Image::ExifTool::Theora::Main' } },
+    Opus   => { SubDirectory => { TagTable => 'Image::ExifTool::Opus::Main' } },
+    FLAC   => { SubDirectory => { TagTable => 'Image::ExifTool::FLAC::Main' } },
+    ID3    => { SubDirectory => { TagTable => 'Image::ExifTool::ID3::Main' } },
+);
+
+#------------------------------------------------------------------------------
+# Process Ogg packet
+# Inputs: 0) ExifTool object ref, 1) data ref
+# Returns: 1 on success
+sub ProcessPacket($$)
+{
+    my ($et, $dataPt) = @_;
+    my $rtnVal = 0;
+    if ($$dataPt =~ /^(.)(vorbis|theora)/s or $$dataPt =~ /^(OpusHead|OpusTags)/) {
+        my ($tag, $type, $pos) = $2 ? (ord($1), ucfirst($2), 7) : ($1, 'Opus', 8);
+        # this is an OGV file if it contains Theora video
+        $et->OverrideFileType('OGV') if $type eq 'Theora' and $$et{FILE_TYPE} eq 'OGG';
+        $et->OverrideFileType('OPUS') if $type eq 'Opus' and $$et{FILE_TYPE} eq 'OGG';
+        my $tagTablePtr = GetTagTable("Image::ExifTool::${type}::Main");
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
+        return 0 unless $tagInfo and $$tagInfo{SubDirectory};
+        my $subdir = $$tagInfo{SubDirectory};
+        my %dirInfo = (
+            DataPt   => $dataPt,
+            DirName  => $$tagInfo{Name},
+            DirStart => $pos,
+        );
+        my $table = GetTagTable($$subdir{TagTable});
+        # set group1 so Theoris comments can be distinguised from Vorbis comments
+        $$et{SET_GROUP1} = $type if $type eq 'Theora';
+        SetByteOrder($$subdir{ByteOrder}) if $$subdir{ByteOrder};
+        $rtnVal = $et->ProcessDirectory(\%dirInfo, $table);
+        SetByteOrder('II');
+        delete $$et{SET_GROUP1};
+    }
+    return $rtnVal;
+}
+
+#------------------------------------------------------------------------------
+# Extract information from an Ogg file
+# Inputs: 0) ExifTool object reference, 1) dirInfo reference
+# Returns: 1 on success, 0 if this wasn't a valid Ogg file
+sub ProcessOGG($$)
+{
+    my ($et, $dirInfo) = @_;
+
+    # must first check for leading/trailing ID3 information
+    unless ($$et{DoneID3}) {
+        require Image::ExifTool::ID3;
+        Image::ExifTool::ID3::ProcessID3($et, $dirInfo) and return 1;
+    }
+    my $raf = $$dirInfo{RAF};
+    my $verbose = $et->Options('Verbose');
+    my $out = $et->Options('TextOut');
+    my ($success, $page, $packets, $streams, $stream) = (0,0,0,0,'');
+    my ($buff, $flag, %val, $numFlac, %streamPage);
+
+    for (;;) {
+        # must read ahead to next page to see if it is a continuation
+        # (this code would be a lot simpler if the continuation flag
+        #  was on the leading instead of the trailing page!)
+        if ($raf and $raf->Read($buff, 28) == 28) {
+            # validate magic number
+            unless ($buff =~ /^OggS/) {
+                $success and $et->Warn('Lost synchronization');
+                last;
+            }
+            unless ($success) {
+                # set file type and initialize on first page
+                $success = 1;
+                $et->SetFileType();
+                SetByteOrder('II');
+            }
+            $flag = Get8u(\$buff, 5);       # page flag
+            $stream = Get32u(\$buff, 14);   # stream serial number
+            if ($flag & 0x02) {
+                ++$streams;                 # count start-of-stream pages
+                $streamPage{$stream} = $page = 0;
+            } else {
+                $page = $streamPage{$stream};
+            }
+            ++$packets unless $flag & 0x01; # keep track of packet count
+        } else {
+            # all done unless we have to process our last packet
+            last unless %val;
+            ($stream) = sort keys %val;     # take a stream
+            $flag = 0;                      # no continuation
+            undef $raf;                     # flag for done reading
+        }
+
+        if (defined $numFlac) {
+            # stop to process FLAC headers if we hit the end of file
+            last unless $raf;
+            --$numFlac; # one less header packet to read
+        } else {
+            # can finally process previous packet from this stream
+            # unless this is a continuation page
+            if (defined $val{$stream} and not $flag & 0x01) {
+                ProcessPacket($et, \$val{$stream});
+                delete $val{$stream};
+                # only read the first $MAX_PACKETS packets from each stream
+                if ($packets > $MAX_PACKETS * $streams or not defined $raf) {
+                    last unless %val;   # all done (success!)
+                }
+            }
+            # stop processing Ogg if we have scanned enough packets
+            last if $packets > $MAX_PACKETS * $streams and not %val;
+        }
+
+        # continue processing the current page
+        my $pageNum = Get32u(\$buff, 18);   # page sequence number
+        my $nseg = Get8u(\$buff, 26);       # number of segments
+        # calculate total data length
+        my $dataLen = Get8u(\$buff, 27);
+        if ($nseg) {
+            $raf->Read($buff, $nseg-1) == $nseg-1 or last;
+            my @segs = unpack('C*', $buff);
+            # could check that all these (but the last) are 255...
+            foreach (@segs) { $dataLen += $_ }
+        }
+        if (defined $page) {
+            if ($page == $pageNum) {
+                $streamPage{$stream} = ++$page;
+            } else {
+                $et->Warn('Missing page(s) in Ogg file');
+                undef $page;
+                delete $streamPage{$stream};
+            }
+        }
+        # read page data
+        $raf->Read($buff, $dataLen) == $dataLen or last;
+        if ($verbose > 1) {
+            printf $out "Page %d, stream 0x%x, flag 0x%x (%d bytes)\n",
+                   $pageNum, $stream, $flag, $dataLen;
+            $et->VerboseDump(\$buff, DataPos => $raf->Tell() - $dataLen);
+        }
+        if (defined $val{$stream}) {
+            $val{$stream} .= $buff;     # add this continuation page
+        } elsif (not $flag & 0x01) {    # ignore remaining pages of a continued packet
+            # ignore the first page of any packet we aren't parsing
+            if ($buff =~ /^(.(vorbis|theora)|Opus(Head|Tags))/s) {
+                $val{$stream} = $buff;      # save this page
+            } elsif ($buff =~ /^\x7fFLAC..(..)/s) {
+                $numFlac = unpack('n',$1);
+                $val{$stream} = substr($buff, 9);
+            }
+        }
+        if (defined $numFlac) {
+            # stop to process FLAC headers if we have them all
+            last if $numFlac <= 0;
+        } elsif (defined $val{$stream} and $flag & 0x04) {
+            # process Ogg packet now if end-of-stream bit is set
+            ProcessPacket($et, \$val{$stream});
+            delete $val{$stream};
+        }
+    }
+    if (defined $numFlac and defined $val{$stream}) {
+        # process FLAC headers as if it was a complete FLAC file
+        require Image::ExifTool::FLAC;
+        my %dirInfo = ( RAF => new File::RandomAccess(\$val{$stream}) );
+        Image::ExifTool::FLAC::ProcessFLAC($et, \%dirInfo);
+    }
+    return $success;
+}
+
+1;  # end
+
+__END__
+
+=head1 NAME
+
+Image::ExifTool::Ogg - Read Ogg meta information
+
+=head1 SYNOPSIS
+
+This module is used by Image::ExifTool
+
+=head1 DESCRIPTION
+
+This module contains definitions required by Image::ExifTool to extract meta
+information from Ogg bitstream container files.
+
+=head1 AUTHOR
+
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
+
+This library is free software; you can redistribute it and/or modify it
+under the same terms as Perl itself.
+
+=head1 REFERENCES
+
+=over 4
+
+=item L<http://www.xiph.org/vorbis/doc/>
+
+=item L<http://flac.sourceforge.net/ogg_mapping.html>
+
+=item L<http://www.theora.org/doc/Theora.pdf>
+
+=back
+
+=head1 SEE ALSO
+
+L<Image::ExifTool::TagNames/Ogg Tags>,
+L<Image::ExifTool(3pm)|Image::ExifTool>
+
+=cut
+
